<?php

function get_ip_list($ips)
{
    $ips = explode('.', $ips);
    if (count($ips) != 4) {
        return false;
    }
    $x = -1;
    $start = -1;
    $end = -1;
    foreach ($ips as $key => $value) {
        if (strpos($value, '*') !== false) {
            $x = $key;
            $start = 0;
            $end = 255;
            break;
        } elseif (strpos($value, '-') !== false) {
            $arr = explode('-', $value);
            if (count($arr) == 2) {
                $x = $key;
                $start = $arr[0];
                $end = $arr[1];
                unset($arr);
            }
            break;
        }
    }
    if ($x == -1 || $start == -1 || $end == -1) {
        return false;
    } else {
        return array('x' => $x, 'start' => $start, 'end' => $end);
    }
}

function is_ipaddress($ip_address = '')
{
    /* check for ipv4/v6 */
    if (substr_count($ip_address, ":")) {
        /* compressed dot format */
        if (substr_count($ip_address, "::")) {
            $ip_address = str_replace("::", ":", $ip_address);
            $segments = explode(":", $ip_address);
        } else {
            $segments = explode(":", $ip_address);
            if (sizeof($segments) != 8) {
                /* should be 8 segments */
                return false;
            }
        }
        $i = 0;
        foreach ($segments as $segment) {
            $i++;

            if ((trim($segment) == "") && ($i == 1)) {
                continue;
            } elseif (!is_numeric("0x" . $segment)) {
                return false;
            }
        }
        return true;
    } else if (strlen($ip_address) <= 15) {
        $octets = explode('.', $ip_address);
        $i = 0;
        if (count($octets) != 4) {
            return false;
        }
        foreach ($octets as $octet) {
            if ($i == 0 || $i == 3) {
                if (($octet < 0) || ($octet > 255)) {
                    return false;
                }
            } else {
                if (($octet < 0) || ($octet > 255)) {
                    return false;
                }
            }
            $i++;
        }
        return true;
    } else {
        return false;
    }
}

//日志写入
function logs($uid, $info, $zcz)
{
    global $DB;
    $ip = real_ip();
    
    $userinfo = $DB->get_row("SELECT * FROM cly_users WHERE uid='$uid' limit 1");
    if (empty($userinfo)) {
        return false;
    }
    $user = $userinfo["user"];
    $date = date("Y-m-d H:i:s");
    if ($DB->query("insert into `cly_logs` ( `uid`,`user`,`info`,`time`,`ip`,`zcz`) values ('$uid','$user', '$info', '$date', '$ip', '$zcz')")) {
        return true;
    } else {
        return false;
    }
}

function op_logs($user, $server, $info)
{
    global $DB;
    $info = '分区：' . $server . ' 操作：' . $info;
    $ip = real_ip();
    $date = date("Y-m-d H:i:s");
    if ($DB->query("insert into `cly_op_logs` ( `user`,`info`,`time`,`ip`) values ('$user', '$info', '$date', '$ip')")) {
        return true;
    } else {
        return false;
    }
}


//余额操作
function money($uid, $money, $crease = true, $tc = false,$msg='')
{
    global $DB;
    $userinfo = $DB->get_row("SELECT * FROM cly_users WHERE uid='$uid' limit 1");
    if (empty($userinfo)) {
        return false;
    }
    if ($crease) {
        $money1 = $money;
        $money2 = $money;
        $money += $userinfo['money'];
        if ($DB->query("update `cly_users` set money='{$money}' where uid='{$uid}'")) {
            if ($tc && $userinfo['ParentID'] != 0) {
                $userinfo2 = $DB->get_row("SELECT * FROM cly_users WHERE uid='" . $userinfo['ParentID'] . "' limit 1");
                if ($userinfo2['is_daili'] == 1) {
                    $money2 = $money2 * $userinfo2['point'] / 100;
                    $DB->query("update `cly_users` set been_tc=been_tc+'{$money2}' , zcz=zcz+'{$money1}' where uid='" . $userinfo['ParentID'] . "'");
                    logs($userinfo['ParentID'], $userinfo['user'] . '充值' . $money1 . '元', $userinfo2['zcz'] + $money1);
                }
            }
            logs($uid, $msg.'余额增加：' . $money1 . '元');
            return true;
        }

    } else {
        if ($userinfo['money'] <= $money) {
            if ($DB->query("update `cly_users` set money='0.00' where uid='{$uid}'")) {
                logs($uid, $msg.'余额减少：' . $money . '元');
                return true;
            }
        } else {
            $userinfo['money'] -= $money;
            if ($DB->query("update `cly_users` set money='{$userinfo['money']}' where uid='{$uid}'")) {
                logs($uid, $msg.'余额减少：' . $money . '元');
                return true;
            }
        }
    }
    return false;
}

//获取用户状态
function GetUserStatu($a)
{
    if ($a == 1) {
        return '封禁';
    } else {
        return '正常';
    }
}

// 生成唯一id
function uuid()
{
    $chars = md5(uniqid(mt_rand(), true));
    $uuid = substr($chars, 0, 8) . '-'
        . substr($chars, 8, 4) . '-'
        . substr($chars, 12, 4) . '-'
        . substr($chars, 16, 4) . '-'
        . substr($chars, 20, 12);
    return $uuid;
}

// 删除文件
function delFile($path)
{
    $url = iconv('utf-8', 'gbk', $path);
    if (PATH_SEPARATOR == ':') { //linux
        unlink($path);
    } else {  //Windows
        unlink($url);
    }
}

//获取post参数
function GetPost($str)
{
    if (isset($_POST[$str]) && $_POST[$str] != "") {
        return daddslashes($_POST[$str]);
    } else {
        json(array('code' => 0, 'msg' => $str . '参数为空！'));
    }
}

//获取get参数
function GetGet($str)
{
    if (isset($_GET[$str]) && $_GET[$str] != "") {
        return daddslashes($_GET[$str]);
    } else {
        json(array('code' => 0, 'msg' => '参数为空！'));
    }
}

//生成json
function json(array $res)
{
    exit(json_encode($res));
}

//密码加密
function getpwd($str)
{
    return md5($str . md5($str) . $str);
}

function curl_get($url)
{
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Linux; U; Android 4.4.1; zh-cn; R815T Build/JOP40D) AppleWebKit/533.1 (KHTML, like Gecko)Version/4.0 MQQBrowser/4.5 Mobile Safari/533.1');
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    $content = curl_exec($ch);
    curl_close($ch);
    return ($content);
}

function real_ip()
{
    $ip = $_SERVER['REMOTE_ADDR'];
    if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && preg_match_all('#\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}#s', $_SERVER['HTTP_X_FORWARDED_FOR'], $matches)) {
        foreach ($matches[0] as $xip) {
            if (!preg_match('#^(10|172\.16|192\.168)\.#', $xip)) {
                $ip = $xip;
                break;
            }
        }
    } elseif (isset($_SERVER['HTTP_CLIENT_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_CLIENT_IP'])) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    } elseif (isset($_SERVER['HTTP_CF_CONNECTING_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_CF_CONNECTING_IP'])) {
        $ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
    } elseif (isset($_SERVER['HTTP_X_REAL_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_X_REAL_IP'])) {
        $ip = $_SERVER['HTTP_X_REAL_IP'];
    }
    return $ip;
}

function get_ip_city($ip)
{
    $url = 'http://int.dpool.sina.com.cn/iplookup/iplookup.php?format=json&ip=';
    @$city = curl_get($url . $ip);
    $city = json_decode($city, true);
    if ($city['city']) {
        $location = $city['province'] . $city['city'];
    } else {
        $location = $city['province'];
    }
    if ($location) {
        return $location;
    } else {
        return false;
    }
}

function daddslashes($string, $force = 0, $strip = FALSE)
{
    !defined('MAGIC_QUOTES_GPC') && define('MAGIC_QUOTES_GPC', get_magic_quotes_gpc());
    if (!MAGIC_QUOTES_GPC || $force) {
        if (is_array($string)) {
            foreach ($string as $key => $val) {
                $string[$key] = daddslashes($val, $force, $strip);
            }
        } else {
            $string = addslashes($strip ? stripslashes($string) : $string);
        }
    }
    return $string;
}

function safestr($str)
{
    if (!get_magic_quotes_gpc()) {
        return addslashes($str);
    } else {
        return $str;
    }
}

function strexists($string, $find)
{
    return !(strpos($string, $find) === FALSE);
}

function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0)
{
    $ckey_length = 4;
    $key = md5($key ? $key : ENCRYPT_KEY);
    $keya = md5(substr($key, 0, 16));
    $keyb = md5(substr($key, 16, 16));
    $keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length) : substr(md5(microtime()), -$ckey_length)) : '';
    $cryptkey = $keya . md5($keya . $keyc);
    $key_length = strlen($cryptkey);
    $string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0) . substr(md5($string . $keyb), 0, 16) . $string;
    $string_length = strlen($string);
    $result = '';
    $box = range(0, 255);
    $rndkey = array();
    for ($i = 0; $i <= 255; $i++) {
        $rndkey[$i] = ord($cryptkey[$i % $key_length]);
    }
    for ($j = $i = 0; $i < 256; $i++) {
        $j = ($j + $box[$i] + $rndkey[$i]) % 256;
        $tmp = $box[$i];
        $box[$i] = $box[$j];
        $box[$j] = $tmp;
    }
    for ($a = $j = $i = 0; $i < $string_length; $i++) {
        $a = ($a + 1) % 256;
        $j = ($j + $box[$a]) % 256;
        $tmp = $box[$a];
        $box[$a] = $box[$j];
        $box[$j] = $tmp;
        $result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
    }
    if ($operation == 'DECODE') {
        if ((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26) . $keyb), 0, 16)) {
            return substr($result, 26);
        } else {
            return '';
        }
    } else {
        return $keyc . str_replace('=', '', base64_encode($result));
    }
}

function get_sz($len = 20)
{
    $str = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    $strlen = strlen($str);
    $randstr = '';
    for ($i = 0; $i < $len; $i++) {
        $randstr .= $str[mt_rand(0, $strlen - 1)];
    }
    return $randstr;
}

function random($length, $numeric = 0)
{
    $seed = base_convert(md5(microtime() . $_SERVER['DOCUMENT_ROOT']), 16, $numeric ? 10 : 35);
    $seed = $numeric ? (str_replace('0', '', $seed) . '012340567890') : ($seed . 'zZ' . strtoupper($seed));
    $hash = '';
    $max = strlen($seed) - 1;
    for ($i = 0; $i < $length; $i++) {
        $hash .= $seed{
        mt_rand(0, $max)};
    }
    return $hash;
}

function substr_cut($user_name){
    $strlen     = mb_strlen($user_name, 'utf-8');
    $firstStr     = mb_substr($user_name, 0, 1, 'utf-8');
    $lastStr     = mb_substr($user_name, -1, 1, 'utf-8');
    return $strlen == 2 ? $firstStr . str_repeat('*', mb_strlen($user_name, 'utf-8') - 1) : $firstStr . str_repeat("*", $strlen - 2) . $lastStr;
}

function showmsg($content = '未知的异常', $type = 4, $back = false, $title)
{
    switch ($type) {
        case 1:
            $panel = "success";
            break;
        case 2:
            $panel = "info";
            break;
        case 3:
            $panel = "warning";
            break;
        case 4:
            $panel = "danger";
            break;
    }
    echo '<div class="panel panel-' . $panel . '">
      <div class="panel-heading">
        <h3 class="panel-title">提示信息</h3>
        </div>
        <div class="panel-body">';
    echo $content;

    if ($back) {
        echo '<hr/><a href="' . $back . '"><< 返回' . $title . '</a>';
        echo '<br/><a href="javascript:history.back(-1)"><< 返回上一页</a>';
    } else
        echo '<hr/><a href="javascript:history.back(-1)"><< 返回上一页</a>';

    echo '</div>
    </div>';
}
